{RESOURCE STATS
	by Steve Willer of Mark Data Management (Copyright 1992)
	This program is copyright, but you may use any function or whatever in
	this source. The only prohibited thing is the re-releasing of code
	edited by you, with my name still on it. If you're going to do this,
	take my name and company name out and don't re-release the docs. I don't
	want people bugging me about code I didn't write.
	This code shouldn't hurt your system, but I make no guarantees. Since
	this is freeware, you hold your own responsibility for using it and the
	problems that may arrive thus. If there are bugs or suggestions, though,
	by all means contact me.
	If there are any questions as to what's going on in the code or you have
	suggestions, by all means contact me. The info is in the docs as well as
	the 'About' box.}

program Resource;

{$R Resource.RES}

uses WObjects, WinTypes, WinProcs, Strings;

function GetHeapSpaces(Handle:THandle):longint; far; external 'KERNEL';
					{Undocumented function that DOES work with Win 3.1. I know there
					 is another function for this purpose that is documented, but
					 the call is very ugly.}


procedure DrawFrame(PaintDC:HDC;PaintR:TRect);
var ThePen,OldPen:HPen;         {This code is completely portable, and}
		FillBrush,OldBrush:HBrush; 	{I have versions for other types of boxes.}
begin
	FillBrush := CreateSolidBrush(GetNearestColor(PaintDC,RGB(180,180,180)));
	OldBrush := SelectObject(PaintDC,FillBrush);
	FillRect(PaintDC,PaintR,FillBrush);
	SelectObject(PaintDC,OldBrush);
	DeleteObject(FillBrush);

	ThePen := CreatePen(ps_Solid,1,GetNearestColor(PaintDC,RGB(255,255,255)));
	OldPen := SelectObject(PaintDC,ThePen);
	MoveTo(PaintDC,PaintR.right,PaintR.top);
	LineTo(PaintDC,PaintR.left,PaintR.top);
	LineTo(PaintDC,PaintR.left,PaintR.bottom);
	MoveTo(PaintDC,PaintR.left+2,PaintR.bottom-2);
	LineTo(PaintDC,PaintR.right-2,PaintR.bottom-2);
	LineTo(PaintDC,PaintR.right-2,PaintR.top+2);
	SelectObject(PaintDC,OldPen);
	DeleteObject(ThePen);

	ThePen := CreatePen(ps_Solid,1,GetNearestColor(PaintDC,RGB(127,127,127)));
	OldPen := SelectObject(PaintDC,ThePen);
	MoveTo(PaintDC,PaintR.right-2,PaintR.top+2);
	LineTo(PaintDC,PaintR.left+2,PaintR.top+2);
	LineTo(PaintDC,PaintR.left+2,PaintR.bottom-2);
	MoveTo(PaintDC,PaintR.left,PaintR.bottom);
	LineTo(PaintDC,PaintR.right,PaintR.bottom);
	LineTo(PaintDC,PaintR.right,PaintR.top);
	SelectObject(PaintDC,OldPen);
	DeleteObject(ThePen);
end;

type
	TResourceApp = object(TApplication)
		procedure InitMainWindow; virtual;
	end;

	PResourceWindow = ^TResourceWindow;
	TResourceWindow = object(TWindow)
		function GetClassName: PChar; virtual;
		procedure SetupWindow; virtual;
		procedure GetWindowClass(var AWndClass: TWndClass); virtual;
		procedure Paint(PaintDC:HDC; var PaintInfo:TPaintStruct); virtual;
		procedure WMDestroy(var Msg:TMessage); virtual wm_First+wm_Destroy;
		procedure About;
		procedure WMQueryOpen(var Msg:TMessage); virtual wm_First+wm_QueryOpen;
		procedure WMSysCommand(var Msg:TMessage); virtual wm_First+wm_SysCommand;
		procedure WMTimer(var Msg:TMessage); virtual wm_First+wm_Timer;
	end;

var
	R:TRect;
	PctTxt:array[0..4] of Char;

const
	sc_About=100;
	sc_Options=101;

procedure TResourceApp.InitMainWindow;
begin
	MainWindow := New(PResourceWindow, Init(nil, 'Resource Stats'));
end;

function TResourceWindow.GetClassName: PChar;
begin
	GetClassName := 'ResourceWindow'
end;

procedure TResourceWindow.GetWindowClass(var AWndClass: TWndClass);
begin
	TWindow.GetWindowClass(AWndClass);
	AWndClass.HIcon := 0; {This is a necessary line. It tells Windows to
												 leave the iconized window blank, allowing a
												 program to draw on it.}
end;

procedure TResourceWindow.SetupWindow;
var ResMenu:HMenu;
		T:longint;
begin
	TWindow.SetupWindow;
	if SetTimer(HWindow,20,500,nil)=0 then  {timer set for 1/2 second}
	begin
		MessageBox(HWindow,'Too many timers in use. Cannot load.',
							 'Resource Stats',mb_IconExclamation or mb_OK);
		CloseWindow;
	end;
	UpdateWindow(HWindow);
	ResMenu:=GetSystemMenu(HWindow,false);
{	EnableMenuItem(ResMenu,sc_Maximize,mf_ByCommand or mf_Grayed or mf_Disabled);
	EnableMenuItem(ResMenu,sc_Restore,mf_ByCommand or mf_Grayed or mf_Disabled);}
	DeleteMenu(ResMenu,sc_Restore,mf_ByCommand);
	DeleteMenu(ResMenu,sc_Maximize,mf_ByCommand);
			{This is a weird one - I couldn't gray Restore and Maximize for
			 some reason...so I deleted them. Pretty unnecessary. If someone
			 could tell me what I'm doing wrong here, could you please tell me?}
	AppendMenu(ResMenu,mf_String,0,nil);
	AppendMenu(ResMenu,mf_String,sc_About,'&About Resource Stats...');
	SendMessage(HWindow,wm_Timer,1,0);
end;

procedure TResourceWindow.Paint(PaintDC:HDC;var PaintInfo:TPaintStruct);
var TextMetrics:TTextMetric;
begin
	with R do
	begin
		Right:=GetSystemMetrics(sm_CXIcon)+3;
		Bottom:=GetSystemMetrics(sm_CYIcon)+3;
		Left:=0;Top:=0;
	end;
	DrawFrame(PaintDC,R);
	SetBkMode(PaintDC,Transparent);
	SetTextAlign(PaintDC,ta_Bottom);
	SetTextColor(PaintDC,RGB(0,0,0));
	GetTextMetrics(PaintDC,TextMetrics);
	TextOut(PaintDC,Round((R.right-GetTextExtent(PaintDC,PctTxt,StrLen(PctTxt)))/2),
		R.bottom-Round((R.bottom-TextMetrics.tmHeight-2)/2),PctTxt,StrLen(PctTxt));
	{You may notice that if the window gets uncovered, it doesn't immediately
	 redraw itself. The structure of this program dictated that this would be
	 an infinite loop, and it didn't seem worth it to rewrite this program,
	 considering that the timer is 500ms, anyway...}
end;

procedure TResourceWindow.WMTimer(var Msg:TMessage);
var
	wFree,wSize:word;
	GDIPct,UserPct,dwInfo:longint;
	PctTxtT:array[0..4] of char;
	PctNum:string;
begin
	dwInfo:=GetHeapSpaces(GetModuleHandle('GDI'));
	wSize:=HiWord(dwInfo);
	wFree:=LoWord(dwInfo);
	GDIPct:=Round(wFree/wSize*100);
	dwInfo:=GetHeapSpaces(GetModuleHandle('User'));
	wSize:=HiWord(dwInfo);
	wFree:=LoWord(dwInfo);
	UserPct:=Round(wFree/wSize*100);
	if GDIPct<UserPct
		then Str(GDIPct,PctNum)
		else Str(UserPct,PctNum);
	StrPCopy(PctTxtT,PctNum+'%');
	if (StrPas(PctTxtT) <> StrPas(PctTxt)) or (Msg.wParam=1) then
	begin
		StrPCopy(PctTxt,PctTxtT);
		InvalidateRect(HWindow,nil,false);
		UpdateWindow(HWindow);
	end;
end;

procedure TResourceWindow.WMQueryOpen(var Msg:TMessage);
begin
	Msg.Result:=0;
end;

procedure TResourceWindow.WMDestroy(var Msg:TMessage);
begin
	KillTimer(HWindow,20);
	TWindow.WMDestroy(Msg);
end;

procedure TResourceWindow.WMSysCommand(var Msg:TMessage);
begin
	case Msg.wParam of
		sc_About:
				About  {I was thinking about adding an Options... menu item.}
		else			 {That's why this unnecessary Case command is here.}
			DefWndProc(Msg);
	end;
end;

procedure TResourceWindow.About;
var Dialog:TDialog;
begin
	Dialog.Init(@Self, 'About');
	Dialog.Execute;
	Dialog.Done;
end;

var
	ResourceApp: TResourceApp;

begin
	CmdShow:=sw_Minimize;
	ResourceApp.Init('ResourceApp');
	ResourceApp.Run;
	ResourceApp.Done;
end.
